<?php
defined('_SITEGUARDING_WAP') or die;

class FUNC_WAP2_extensions
{
    public static function PageHTML()  
    {
        wp_enqueue_style( 'plgwap2_LoadStyle_UI' );
        wp_enqueue_script( 'plgwap2_LoadJS_UI', '', array(), false, true );
        
        $data = self::GetExtensionsInfo();
        
        
        $action = isset( $_REQUEST['action'] ) ? $_REQUEST['action'] : ''; 
        if ($action == 'Install')
        {
            $id = isset( $_REQUEST['id'] ) ? $_REQUEST['id'] : 0; 
            
            $download = $data[$id]['download'];
            $slug = $data[$id]['slug'];
            $redirect = $data[$id]['redirect'];

            self::Installer_from_URL($download, $slug, $redirect);
            return;
        }
        
        ?>

        <?php
            FUNC_WAP2_general::Wait_CSS_Loader();
        ?>
        
        
        <div id="main" class="ui main container" style="float: left;margin-top:20px;display:none">
            <h2 class="ui dividing header">Security extensions</h2>
            
            
            <div class="ui icon green message">
                <i class="thumbs up outline icon"></i>
                <div class="content">
                    <h2 class="ui header sg_center">Try our extensions</h2>
                    <p class="fnt-size-110">Our plugins can add a higher level of security to your WordPress website. You can try all of them absolutely free. <b>Premium customers</b> can get full version of all our plugins. Request your unlock code from <a href="https://www.siteguarding.com/en/contacts" target="_blank">SiteGuarding.com support</a></p>
                    <p class="sg_center">
                        <a class="medium positive ui button" href="<?php echo FUNC_WAP2_general::$LINKS['upgrade_to_premium']; ?>" target="_blank">Upgrade to Premium</a>
                    </p>
                </div>
            </div>
            
            <?php /*
            <div class="ui three column grid">
            
            <?php
            foreach ($items as $item) {
            ?>
              <div class="column">
                <div class="ui segment full_h">
                    <h3 class="ui dividing header"><img src="<?php echo $item['logo']; ?>"/>
                        <?php echo $item['title']; ?></h3>
                    <div class="ui list">
                        <?php
                        foreach ($item['list'] as $row) {
                        ?>
                            <a class="item"><i class="right triangle icon"></i><div class="content"><div class="description"><?php echo $row; ?></div></div></a>
                        <?php
                        }
                        ?>
                    </div>
                    <p style="text-align: center;"><a class="ui medium positive button" href="<?php echo $item['link']; ?>" target="_blank">Learn more</a></p>
                </div>
              </div>
            <?php
            }
            ?>
              
            </div>
            */ ?>
            
            
            
            
            <script>
            function ShowLoadingIcon(el)
            {
                jQuery(el).html('<i class="asterisk loading icon"></i>');
            }
            </script>
            <div class="ui cards">
            <?php
            foreach ($data as $id => $ext) 
            {
                $install_url = 'admin.php?page=plgwap2_extensions_page&action=Install&id='.$id
            ?>
              <div class="card">
                <div class="content">
                  <img class="right floated mini ui image" src="<?php echo $ext['logo']; ?>">
                  <div class="header">
                    <?php echo $ext['title']; ?>
                  </div>
                  <div class="description">
                    <ul class="ui list">
                    <?php
                        foreach ($ext['list'] as $list_item) echo '<li>'.$list_item.'</li>';
                    ?>
                    </ul>
                  </div>
                </div>
                <div class="extra content">
                  <?php /* <div class="ui two buttons"> */ ?>
                    <a class="ui basic green button" href="<?php echo $ext['link']; ?>" target="_blank">More details</a>
                    <a class="ui basic red button" href="<?php echo $install_url; ?>" onclick="ShowLoadingIcon(this);">Install & Try</a>
                   <?php /* </div> */ ?>
                </div>
              </div>
            <?php
            }
            ?>
                
                
            </div>
            
            
        </div>
        <?php
    } 
    
    
    
    public static function GetExtensionsInfo()
    {
        $a = array();
        
        $json_file = dirname(dirname(__FILE__)).DIRSEP.'tmp'.DIRSEP.'extensions.json';
        
        if (!file_exists($json_file) || time() - filectime($json_file) > 30 * 24 * 60 * 60)
        {
            self::UpdateExtJSON($json_file);
        }
        
        if (file_exists($json_file))
        {
            $a = FUNC_WAP2_general::ReadFile($json_file, true);
        }
        
        return $a;
    }


    public static function UpdateExtJSON($filename)
    {
        $request_url = 'https://www.siteguarding.com/files/updateinfo/wordpress/extensions.json';
        $response = wp_remote_get($request_url);
        $json = (array)json_decode($response['body'], true);
        if (isset($json[0]['title']))
        {
            $fp = fopen($filename, 'w');
            fwrite($fp, $response['body']);
            fclose($fp);
        }
    }
    
    
    public static function Installer_from_URL($download, $slug, $redirect)
    {
        require_once ABSPATH . 'wp-admin/includes/class-wp-upgrader.php';
        
        $pluginDir = WP_PLUGIN_DIR . '/' . $slug;
        
        if (!file_exists($pluginDir))
        {
    		$upgrader = new Plugin_Upgrader( new Plugin_Installer_Skin() );
    		$upgrader->install( $download );
            rename($upgrader->result['destination'], $pluginDir);
        }
        

        $pluginPath = $pluginDir . '/' . $slug . '.php';
        
        activate_plugin($slug.'/'.$slug.'.php');
        
        if ($redirect != '')
        {
            ?>
            <script>
            jQuery(document).ready(function(){
                jQuery(".wrap").hide();
                location.href = "<?php echo admin_url( $redirect ); ?>";
            });
            </script>
            <?php
        }
    }
}

?>